#include "extgraph.h"

//===================================================================================//

void Sprite8_GRIS_OR(short x, short y, unsigned char *sprite1, unsigned char *sprite2)
{
	GrayClipSprite8_OR_R(ADAPT_x+x, ADAPT_y+y, 8, sprite1, sprite2, plan0, plan1);
}

//===================================================================================//

void Sprite8_GRIS_XOR(short x, short y, unsigned char *sprite1, unsigned char *sprite2)
{
	GrayClipSprite8_XOR_R(ADAPT_x+x, ADAPT_y+y, 8, sprite1, sprite2, plan0, plan1);
}

//===================================================================================//

void Sprite16_GRIS_XOR(short x, short y, unsigned short *sprite1, unsigned short *sprite2)
{
	GrayClipSprite16_XOR_R(ADAPT_x+x, ADAPT_y+y, 16, sprite1, sprite2, plan0, plan1);
}

//===================================================================================//

void Sprite16_GRIS_AND(short x, short y, unsigned short *sprite1, unsigned short *sprite2)
{
	GrayClipSprite16_AND_R(ADAPT_x+x, ADAPT_y+y, 16, sprite1, sprite2, plan0, plan1);
}

//===================================================================================//

void Sprite32_GRIS(short x, short y, unsigned long *sprite1, unsigned long *sprite2)
{
	GrayClipSprite32_XOR_R(ADAPT_x+x, ADAPT_y+y, 32, sprite1, sprite2, plan0, plan1);
}

//===================================================================================//

void AfficheBmp(short x,short y, unsigned char *bitmap, short mode, short plan)
{
	GraySetAMSPlane(plan);
	BitmapPut(ADAPT_x+x, ADAPT_y+y, bitmap, &ecran, mode);	
}

//===================================================================================//

void SauveImg(unsigned char * buffer)
{
	memcpy(buffer, plan0, LCD_SIZE);
	memcpy(buffer+LCD_SIZE, plan1, LCD_SIZE);
}

//===================================================================================//

void RestaureImg(unsigned char * buffer)
{
	memcpy(plan0, buffer, LCD_SIZE);
	memcpy(plan1, buffer+LCD_SIZE, LCD_SIZE);
}

//===================================================================================//

void DessineContourRect(short x1, short y1, short x2, short y2, short mode, short plan)
{
	GraySetAMSPlane(plan);
	DrawClipRect(MakeWinRect(ADAPT_x+x1, ADAPT_y+y1, ADAPT_x+x2, ADAPT_y+y2), &ecran, mode);
}

//===================================================================================//

void DessineRectPlein(short x1, short y1, short x2, short y2, short mode, short plan)
{
	SCR_RECT rect = {{ADAPT_x+x1, ADAPT_y+y1, ADAPT_x+x2, ADAPT_y+y2}};
	GraySetAMSPlane(plan);
	ScrRectFill(&rect, &ecran, mode);	
}

//===================================================================================//

void EffacePlans(void)
{
	GrayFastFillRect_R(plan0, plan1, ADAPT_x, ADAPT_y, 159+ADAPT_x, 100+ADAPT_y, COLOR_WHITE);
}

//===================================================================================//

void DessineLigne(short x1, short y1, short x2, short y2, short mode, short plan)
{
	GraySetAMSPlane(plan);
	DrawLine(ADAPT_x+x1, ADAPT_y+y1, ADAPT_x+x2, ADAPT_y+y2, mode);
}

//===================================================================================//

void AfficheChaine(short x, short y, const char *str, short mode, short plan, short taille)
{
	GraySetAMSPlane(plan);
	FontSetSys(taille);
	DrawStr(ADAPT_x+x, ADAPT_y+y, str, mode);
}

//===================================================================================//

void AfficheNb(short x, short y, unsigned long num, short num_zero, short mode, short plan, short taille)
{
  char buffer[7];
  char string[7] = "%05lu"; // 5 zros par dfaut
  string[2] = 48+num_zero;
  sprintf(buffer, string, num);
  AfficheChaine(x, y, buffer, mode, plan, taille);
}

//===================================================================================//

void EffacePiece(short x, short y, short piece, short position)
{
	register short i;
	
	for(i = 0; i < 16; i ++)
	{
		if(matrice_motifs[piece][position][i])
		{
			Sprite16_GRIS_AND(x+8*(i%4)-1, y+6*(i/4)-1, mask_motifs, mask_motifs);
		}
	}
	
	for(i = 0; i < 16; i ++)
	{
		if(matrice_motifs[piece][position][i])
		{
			Sprite8_GRIS_OR(x+8*(i%4), y+6*(i/4), motifs_0[0], motifs_0[0]);
		}
	}
}

//===================================================================================//

void AffichePiece(short x, short y, short piece, short position)
{
	register short i;
	
	for(i = 0; i < 16; i ++)
	{
		if(matrice_motifs[piece][position][i])
		{
			Sprite16_GRIS_AND(x+8*(i%4)-1, y+6*(i/4)-1, mask_motifs, mask_motifs);
		}
	}
	
	for(i = 0; i < 16; i ++)
	{
		if(matrice_motifs[piece][position][i])
		{
			Sprite8_GRIS_OR(x+8*(i%4), y+6*(i/4), motifs_0[matrice_motifs[piece][position][i]], motifs_1[matrice_motifs[piece][position][i]]);	
		}
	}
}

//===================================================================================//

void DessineShadowSansChercher(short x, short y, short piece, short position)
{
	register short i;
	if(!shadow) return;
	
	for(i = 0; i < 16; i ++)
	{
		if(matrice_motifs[piece][position][i])
		{
			Sprite8_GRIS_OR(x+8*(i%4), y+6*(i/4), motifs_0[0], motifs_1[2]);
		}
	}
}

//===================================================================================//

void EffaceShadow(short x, short y, short piece, short position)
{
	register short i;
	if(!shadow) return;
	
	for(i = 0; i < 16; i ++)
	{
		if(matrice_motifs[piece][position][i])
		{
			Sprite16_GRIS_AND(x+8*(i%4)-1, y+6*(i/4)-1, mask_motifs, mask_motifs);
		}
		 
	}
	
	for(i = 0; i < 16; i ++)
	{
		if(matrice_motifs[piece][position][i])
		{
			Sprite8_GRIS_OR(x+8*(i%4), y+6*(i/4), motifs_0[0], motifs_0[0]);
		}
	}
}

//===================================================================================//